Alembic: Alembic::Abc::ALEMBIC_VERSION_NS::IObject Class Reference

Alembic 1.8.11

Loading...
Searching...
No Matches
Alembic::Abc::ALEMBIC_VERSION_NS::IObject Class Reference
Inheritance diagram for Alembic::Abc::ALEMBIC_VERSION_NS::IObject:

## Public Types
typedef IObject | this_type
typedef IObject | operator_bool_base_type

## Public Member Functions
| IObject ()
| IObject (const IObject &iParent, const std::string &iName, const Argument &iArg0=Argument())
| IObject (AbcA::ObjectReaderPtr iPtr, const Argument &iArg0=Argument())
| IObject (AbcA::ObjectReaderPtr iPtr, WrapExistingFlag, const Argument &iArg0=Argument())
| IObject (IArchive &iArchive, const Argument &iArg0=Argument())
| IObject (IArchive &iArchive, TopFlag iFlag, const Argument &iArg0=Argument())
virtual | ~IObject ()
const AbcA::ObjectHeader & | getHeader () const
const std::string & | getName () const
const std::string & | getFullName () const
const AbcA::MetaData & | getMetaData () const
IArchive | getArchive () const
IObject | getParent () const
size_t | getNumChildren () const
const AbcA::ObjectHeader & | getChildHeader (size_t i) const
const AbcA::ObjectHeader * | getChildHeader (const std::string &iName) const
ICompoundProperty | getProperties () const
IObject | getChild (size_t iChildIndex) const
IObject | getChild (const std::string &iChildName) const
bool | isInstanceRoot () const
| -************************************************************************
bool | isInstanceDescendant () const
std::string | instanceSourcePath () const
bool | isChildInstance (size_t iChildIndex) const
bool | isChildInstance (const std::string &iChildName) const
AbcA::ObjectReaderPtr | getInstancePtr () const
| Returns the original ObjectReaderPtr, if this object is an instance.
AbcA::ObjectReaderPtr | getPtr () const
void | reset ()
| Reset returns this function set to an empty, default state.
bool | valid () const
bool | getPropertiesHash (Util::Digest &oDigest)
bool | getChildrenHash (Util::Digest &oDigest)
| ALEMBIC_OPERATOR_BOOL (valid())
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
ErrorHandler & | getErrorHandler () const
ErrorHandler::Policy | getErrorHandlerPolicy () const

## Public Attributes
AbcA::ObjectReaderPtr | m_object

## Additional Inherited Members
Protected Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
| Base (ErrorHandler::Policy iPolicy)
| Base (const Base &iCopy)
Base & | operator= (const Base &iCopy)
bool | valid () const
void | reset ()

## Member Typedef Documentation

## ◆ this_type

typedef IObject Alembic::Abc::ALEMBIC_VERSION_NS::IObject::this_type

By convention, we always define "this_type" in every Abc class. This convention is relied upon by the unspecified-bool-type conversion.

## Constructor & Destructor Documentation

## ◆ IObject() [1/4]

Alembic::Abc::ALEMBIC_VERSION_NS::IObject::IObject | ( |  | ) |
| inline

The default constructor creates an empty IObject function set. ...

## ◆ IObject() [2/4]

Alembic::Abc::ALEMBIC_VERSION_NS::IObject::IObject | ( | const IObject & | iParent,
|  | const std::string & | iName,
|  | const Argument & | iArg0 = Argument() )
| inline

This function creates a new object reader. The first argument is the Abc IObject parent from which the error handler policy for inheritance is also derived. The remaining optional arguments can be used to override the ErrorHandlerPolicy.

## ◆ IObject() [3/4]

Alembic::Abc::ALEMBIC_VERSION_NS::IObject::IObject | ( | AbcA::ObjectReaderPtr | iPtr,
|  | const Argument & | iArg0 = Argument() )
| inline

This attaches an IObject wrapper around an existing ObjectReaderPtr, with an optional error handling policy.

## ◆ IObject() [4/4]

Alembic::Abc::ALEMBIC_VERSION_NS::IObject::IObject | ( | IArchive & | iArchive,
|  | const Argument & | iArg0 = Argument() )
| inline

This attaches an IObject wrapper around the top object of an archive.

## ◆ ~IObject()

Alembic::Abc::ALEMBIC_VERSION_NS::IObject::~IObject | ( |  | ) |
| virtual

Default copy constructor used Default assignment operator used.

Destructor ...

## Member Function Documentation

## ◆ ALEMBIC_OPERATOR_BOOL()

Alembic::Abc::ALEMBIC_VERSION_NS::IObject::ALEMBIC_OPERATOR_BOOL | ( | valid() |  | ) |

The unspecified-bool-type operator casts the object to "true" if it is valid, and "false" otherwise.

## ◆ getArchive()

IArchive Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getArchive | ( |  | ) | const

This function returns the object's archive, handily wrapped in an IArchive wrapper.

## ◆ getChild() [1/2]

IObject Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getChild | ( | const std::string & | iChildName | ) | const

This function returns an IObject wrapped constructed from the header referenced by the name. If the child of the given name does not exist, this will fail in the same way as if the equivalent constructor was called.

## ◆ getChild() [2/2]

IObject Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getChild | ( | size_t | iChildIndex | ) | const

This function returns an IObject constructed from the indexed object.

## ◆ getChildHeader() [1/2]

const AbcA::ObjectHeader * Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getChildHeader | ( | const std::string & | iName | ) | const

Return the header of an object by name. This will return a NULL pointer if no header by that name is found.

## ◆ getChildHeader() [2/2]

const AbcA::ObjectHeader & Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getChildHeader | ( | size_t | i | ) | const

This function returns the headers of each of the child objects that were written as children of this object.

## ◆ getChildrenHash()

bool Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getChildrenHash | ( | Util::Digest & | oDigest | ) |

If an aggregated child objects hash exists fill oDigest with it and return true, if it doesn't exist return false

## ◆ getFullName()

const std::string & Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getFullName | ( |  | ) | const

The full name of an object is the complete path name all the way to the root object of the archive. It is guaranteed to be fully unique within the entire archive. This is a convenience function which returns the header's full name.

## ◆ getHeader()

const AbcA::ObjectHeader & Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getHeader | ( |  | ) | const

All objects have a header, which contains all the MetaData that was specified upon their creation. This function returns a constant reference to that Header.

## ◆ getMetaData()

const AbcA::MetaData & Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getMetaData | ( |  | ) | const
| inline

All objects have metadata. This metadata is identical to the Metadata of the top level compoundProperty "properties". Because the metadata must exist and be initialized in order to bootstrap the object, it is guaranteed to exist and is returned by reference. This is a convenience function which returns the header's MetaData.

## ◆ getName()

const std::string & Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getName | ( |  | ) | const

All objects have a name. This name is unique amongst their siblings Returned by reference, since it is guaranteed to exist and be unchanging. This is a convenience function which returns the header's name.

## ◆ getNumChildren()

size_t Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getNumChildren | ( |  | ) | const

This function returns the number of child objects that this object has.

## ◆ getParent()

IObject Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getParent | ( |  | ) | const

This function returns the object's parent, handily wrapped in an IObject wrapper. If the object is the top level object, the IObject returned will be NULL.

## ◆ getProperties()

ICompoundProperty Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getProperties | ( |  | ) | const

This returns the single top-level CompoundPropertyReader that exists automatically as part of the object.

## ◆ getPropertiesHash()

bool Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getPropertiesHash | ( | Util::Digest & | oDigest | ) |

If an aggregated properties hash exists fill oDigest with it and return true, if it doesn't exist return false

## ◆ getPtr()

AbcA::ObjectReaderPtr Alembic::Abc::ALEMBIC_VERSION_NS::IObject::getPtr | ( |  | ) | const
| inline

getPtr, as usual, returns a shared ptr to the underlying AbcCoreAbstract object, in this case the ObjectReaderPtr. If this object happens to be an instance, it points to the instance source ObjectReaderPtr

## ◆ instanceSourcePath()

std::string Alembic::Abc::ALEMBIC_VERSION_NS::IObject::instanceSourcePath | ( |  | ) | const

If this object is an instance (isInstanceRoot), returns the source path that the instance points at. Otherwise and empty string is returned.

## ◆ isInstanceDescendant()

bool Alembic::Abc::ALEMBIC_VERSION_NS::IObject::isInstanceDescendant | ( |  | ) | const

Returns whether this object has been arrived at via an instance, or if this object is an instance itself.

## ◆ isInstanceRoot()

bool Alembic::Abc::ALEMBIC_VERSION_NS::IObject::isInstanceRoot | ( |  | ) | const

-************************************************************************

-************************************************************************ Returns whether this object directly instances another object.

## ◆ valid()

bool Alembic::Abc::ALEMBIC_VERSION_NS::IObject::valid | ( |  | ) | const
| inline

Valid returns whether this function set is valid.

The documentation for this class was generated from the following files:

- Abc/IObject.h
- Abc/IObject.cpp